
////////////////////////////////////////////////////////////
//
//  map_compresser.h
//

#ifndef _MAP_COMPRESSER_
#define _MAP_COMPRESSER_

////////////////////////////////////////////////////////////

#include <iostream>
#include <fstream>

typedef unsigned int half;      // half : 4bitf[^(4bit̂܂܂ƖȂ̂intƂď)
typedef unsigned char byte;     // byte : 1bytef[^
typedef unsigned short word;    // word : 2bytef[^


// kwb_[
typedef struct _CMPHeader{
    byte f_byte[4];
    word f_word[17];
} CMPHeader;



namespace RareCompresser{

    // ݗphalfXg[(obt@)
    class ohstream{
        static const int BUF_SIZE = 64;     // obt@TCY
        half buf[BUF_SIZE];     // 4bitf[^z
        int count;              // ~ϐ
        std::ofstream &ofs;     // o͐fileXg[
    public:
        ohstream(std::ofstream &_ofs);
        ~ohstream();
        void puth(half h);      // 1half
        void flush();           // obt@t@Cɗ
    };
    
    // kf[^̈ꎞۊǃobt@
    class UncompBuffer{
        static const int BUF_SIZE = 15;     // obt@TCY(0xF)
        byte buf[BUF_SIZE];     // kf[^
        int count;              // ~ϐ
        ohstream &ohs;          // o͐halfXg[
    public:
        UncompBuffer(ohstream &_ohs);
        ~UncompBuffer();
        void put(byte data);    // f[^ǉ
        void flush();           // f[^halfXg[ɗ
    };
    
    // p^[vf(ŏ̈ꕶ)
    struct PatternElement{
        static const int PTN_SIZE = 17;     // p^[TCY(0xF + 2)
        const byte *ptr;        // f[^ʒu(͈ꕶڂ܂)
        byte pattern[PTN_SIZE]; // p^[
    };
    // p^[obt@:ŏ̈ꕶɑ΂p^[
    class PatternBuffer{
        static const int PTN_MAX = 256;     // i[łp^[
        PatternElement elem[PTN_MAX];       // p^[(Oobt@)
        int index;              // ݂̃CfbNX(PTN_MAX0ɖ߂)
        int count;              // i[p^[(PTN_MAXœł)
    public:
        PatternBuffer();
        ~PatternBuffer();
        int search(const byte *src_sc, const byte **pointer);   // p^[(߂l1ڂp^[)
        void add(const byte *src_pr);                           // p^[ǉ
    };
    // p^[ǗsNX(ŏ̈ꕶł܂Ƃ߂)
    class PatternManager{
        PatternBuffer buffers[256];
    public:
        int search(const byte *src, const byte **pointer);      // p^[(߂l̓p^[)
        void add(const byte *src);                              // p^[ǉ
    };
    
    
    
    // k{
    class Compresser{
        
        const CMPHeader &header;// wb_[
        const byte *data;       // ̓f[^
        int data_size;          // f[^TCY
        
        ohstream ohs;           // o͐
        UncompBuffer uncomp;    // kobt@
        PatternManager pattern; // p^[Ǘ
        
    public:
        
        Compresser(std::ofstream &_ofs, const byte *_data, int _data_size, const CMPHeader &_header);
        ~Compresser();
        
        bool compress();
        
    };


}   // namespace RareCompresser

using RareCompresser::Compresser;



typedef struct _FMF_Header {

	char identifier[4];
	unsigned int size;
	unsigned int mapWidth;
	unsigned int mapHeight;
	unsigned char chipWidth;
	unsigned char chipHeight;
	unsigned char layerCount;
	unsigned char bitCount;

} FMF_Header;



// n`O[v(t@C擾)
typedef struct _MapGroup{
    char name[256];          // O
    unsigned int offset;    // ItZbg(AhX)
    int vertical;           // ʂȂ0, cʂȂ1
    int height;             // (cʂ̏ꍇ)
}MapGroup;




////////////////////////////////////////////////////////////

#endif // _MAP_COMPRESSER





