
////////////////////////////////////////////////////////////
//
//  rare_comp.cpp
//

#include "map_compresser.h"

using namespace std;
using namespace RareCompresser;

Compresser::Compresser(ofstream &_ofs, const byte *_data, int _data_size, const CMPHeader &_header)
: ohs(_ofs), uncomp(ohs), header(_header)
{
    data = _data;
    data_size = _data_size;
}

Compresser::~Compresser(){
}


bool Compresser::compress(){
    
    int index=0;
    
    // p^[(1oCgRs[̂͏)
    const byte *pointer_ptn;    // p^[̏ꍇ̃f[^ʒu
    int length_ptn;             // p^[̏ꍇ̒(0̏ꍇp^[ps)
    int cost_ptn=1;             // p^[̏ꍇ̃RXg
    half out_ptn[6];            // p^[̏ꍇ̏o
    
    // A}(1oCg悭i[ꍇ܂)
    int length_run;             // A}̏ꍇ̒(0̏ꍇA}ps)
    int cost_run=1;             // A}̏ꍇ̃RXg
    half out_run[4];            // A}̏ꍇ̏o
    
    // 2oCg}
    int length_pair;            // 2oCg}̏ꍇ̒(20̏ꍇps)
    int cost_pair=1;            // 2oCg}̏ꍇ̃RXg
    half out_pair[2];           // 2oCg}̏ꍇ̏o
    
    int cost_prd;               // 3ނ̕@̃RXg̐
    int val_ptn;
    int val_run;
    int val_pair;
    int length;
    
    while (index < data_size){
        
        // ܂́Adata[index] (1)n܂p^[Ɉv̂̂Aő̂̂`FbNB
        length_ptn = pattern.search(data+index, &pointer_ptn);
        if (pointer_ptn+length_ptn > data+index)
            length_ptn = data+index-pointer_ptn;    // p^[m̗̈܂ŐioĂAH~߂B
        if (index+length_ptn > data_size)
            length_ptn = data_size-index;           // f[^I[z悤ƂĂAH~߂B
        if (length_ptn != 0){
            int offset_ptn = data+index-pointer_ptn;
            if (length_ptn == 1){
                // 1̏ꍇ
                length_ptn = 0;     // (A}̂قŏ)
            }else if (length_ptn == 2){
                // 2̏ꍇ
                if (offset_ptn == 2){
                    // 2oCgOƂՓIȏꍇ́AR}hEKpłB
                    cost_ptn = 1;
                    out_ptn[0] = 0xE;
                }else if (offset_ptn < 17){
                    // 17oCgȓ猩ꍇ́AR}h9XKpłB
                    cost_ptn = 2;
                    out_ptn[0] = 0x9;
                    out_ptn[1] = offset_ptn-2;
                }else{
                    // ȊȌꍇAcOȂp^[͗płȂB
                    length_ptn = 0;
                }
            }else{
                // 3ȏ̏ꍇ
                int X = length_ptn - 3;     // X͕K0`F
                if (offset_ptn <= X + 0x102){
                    // R}hAXYYKpłB
                    int YY = offset_ptn - X - 3;    // YY͕K00`FF
                    cost_ptn = 4;
                    out_ptn[0] = 0xA;
                    out_ptn[1] = X;
                    out_ptn[2] = (YY & 0xf0) >> 4;
                    out_ptn[3] =  YY & 0x0f;
                }else if (offset_ptn <= 0x1102){
                    // R}hBXYYZKpłB
                    int YYZ = offset_ptn - 0x103;    // YY͕K`FFF
                    cost_ptn = 5;
                    out_ptn[0] = 0xB;
                    out_ptn[1] = X;
                    out_ptn[2] = (YYZ & 0xf00) >> 8;
                    out_ptn[3] = (YYZ & 0x0f0) >> 4;
                    out_ptn[4] =  YYZ & 0x00f;
                }else if (offset_ptn <= 0xFFFF){
                    // R}hCXYYZZKpłB
                    cost_ptn = 6;
                    out_ptn[0] = 0xC;
                    out_ptn[1] = X;
                    out_ptn[2] = (offset_ptn & 0xf000) >> 12;
                    out_ptn[3] = (offset_ptn & 0x0f00) >> 8;
                    out_ptn[4] = (offset_ptn & 0x00f0) >> 4;
                    out_ptn[5] =  offset_ptn & 0x000f;
                }else{
                    // ȊȌꍇAcOȂp^[͗płȂB
                    length_ptn = 0;
                }
            }
        }
        
        // ɁAf[^̘A}̗p`FbNB(1̏ꍇŏEB)
        for (
            length_run=1;
            data[index+length_run]==data[index] && length_run<18 && index+length_run<data_size;
            length_run++    // AĂ邱   ő18oCg    f[^̏I𒴂Ȃ
        );
        if (length_run == 1){
            // 1
            if (data[index] == header.f_byte[2]){
                // R}h7Kp
                cost_run = 1;
                out_run[0] = 0x7;
            }else if (data[index] == header.f_byte[3]){
                // R}h8Kp
                cost_run = 1;
                out_run[0] = 0x8;
            }else{
                // 
                length_run = 0;
            }
        }else if (length_run == 2){
            // 2
            if (data[index] == header.f_byte[2]){
                // R}h72Agp
                cost_run = 2;
                out_run[0] = 0x7;
                out_run[1] = 0x7;
            }else if (data[index] == header.f_byte[3]){
                // R}h82Agp
                cost_run = 2;
                out_run[0] = 0x8;
                out_run[1] = 0x8;
            }else{
                // k{R}hDŌێ
                cost_run = 4;
                out_run[0] = 0x1;
                out_run[1] = (data[index] & 0xf0) >> 4;
                out_run[2] =  data[index] & 0x0f;
                out_run[3] = 0xD;
            }
        }else if (length_run == 3){
            // 3
            if (data[index] == header.f_byte[0]){
                // R}h40
                cost_run = 2;
                out_run[0] = 0x4;
                out_run[1] = 0x0;
            }else if (data[index] == header.f_byte[1]){
                // R}h50
                cost_run = 2;
                out_run[0] = 0x5;
                out_run[1] = 0x0;
            }else if (data[index] == header.f_byte[2]){
                // R}h73A
                cost_run = 3;
                out_run[0] = 0x7;
                out_run[1] = 0x7;
                out_run[2] = 0x7;
            }else if (data[index] == header.f_byte[3]){
                // R}h83A
                cost_run = 3;
                out_run[0] = 0x8;
                out_run[1] = 0x8;
                out_run[2] = 0x8;
            }else{
                // 30XX
                cost_run = 4;
                out_run[0] = 0x3;
                out_run[1] = 0x0;
                out_run[2] = (data[index] & 0xf0) >> 4;
                out_run[3] =  data[index] & 0x0f;
            }
        }else if (length_run == 4){
            // 4
            if (data[index] == header.f_byte[0]){
                cost_run = 2;
                out_run[0] = 0x4;
                out_run[1] = 0x1;
            }else if (data[index] == header.f_byte[1]){
                cost_run = 2;
                out_run[0] = 0x5;
                out_run[1] = 0x1;
            }else if (data[index] == header.f_byte[2]){
                cost_run = 3;
                out_run[0] = 0x7;
                out_run[1] = 0x7;
                out_run[2] = 0xE;
            }else if (data[index] == header.f_byte[3]){
                cost_run = 3;
                out_run[0] = 0x8;
                out_run[1] = 0x8;
                out_run[2] = 0xE;
            }else{
                cost_run = 4;
                out_run[0] = 0x3;
                out_run[1] = 0x1;
                out_run[2] = (data[index] & 0xf0) >> 4;
                out_run[3] =  data[index] & 0x0f;
            }
        }else{
            // 5ȏ
            if (data[index] == header.f_byte[0]){
                cost_run = 2;
                out_run[0] = 0x4;
                out_run[1] = length_run - 3;
            }else if (data[index] == header.f_byte[1]){
                cost_run = 2;
                out_run[0] = 0x5;
                out_run[1] = length_run - 3;
            }else{
                cost_run = 4;
                out_run[0] = 0x3;
                out_run[1] = length_run - 3;
                out_run[2] = (data[index] & 0xf0) >> 4;
                out_run[3] =  data[index] & 0x0f;
            }
        }
        
        // ܂A2oCg݂B
        if (index+1 != data_size){
            int word = data[index] | (data[index+1] << 8);
            if (word == header.f_word[0]){
                length_pair = 2;
                cost_pair = 1;
                out_pair[0] = 0x6;
            }else if (word == header.f_word[1]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x0;
            }else if (word == header.f_word[2]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x1;
            }else if (word == header.f_word[3]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x2;
            }else if (word == header.f_word[4]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x3;
            }else if (word == header.f_word[5]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x4;
            }else if (word == header.f_word[6]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x5;
            }else if (word == header.f_word[7]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x6;
            }else if (word == header.f_word[8]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x7;
            }else if (word == header.f_word[9]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x8;
            }else if (word == header.f_word[10]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0x9;
            }else if (word == header.f_word[11]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xA;
            }else if (word == header.f_word[12]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xB;
            }else if (word == header.f_word[13]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xC;
            }else if (word == header.f_word[14]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xD;
            }else if (word == header.f_word[15]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xE;
            }else if (word == header.f_word[16]){
                length_pair = 2; cost_pair = 2; out_pair[0] = 0xF; out_pair[1] = 0xF;
            }else{
                length_pair = 0;
            }
        }else{
            // f[^̏I肶ᖳ
            length_pair = 0;
        }
        
        
        // ł́A悢rĕ@肷B
        cost_prd = cost_ptn * cost_run * cost_pair;
        val_ptn  = cost_prd * length_ptn  / cost_ptn;
        val_run  = cost_prd * length_run  / cost_run;
        val_pair = cost_prd * length_pair / cost_pair;
        if (val_ptn > val_run){
            if (val_ptn > val_pair){
                // p^[pő
                if (length_ptn != 0){
                    // p^[p
                    length = length_ptn;
                    uncomp.flush();
                    for (int i=0; i<cost_ptn; i++) ohs.puth(out_ptn[i]);
                }else{
                    // ݔs
                    length = 1;
                    uncomp.put(data[index]);
                }
            }else{
                // yApő
                if (length_pair != 0){
                    // yAp
                    length = length_pair;
                    uncomp.flush();
                    for (int i=0; i<cost_pair; i++) ohs.puth(out_pair[i]);
                }else{
                    // ݔs
                    length = 1;
                    uncomp.put(data[index]);
                }
            }
        }else{
            if (val_run > val_pair){
                // A}ő
                if (length_run != 0){
                    // A}p
                    length = length_run;
                    uncomp.flush();
                    for (int i=0; i<cost_run; i++) ohs.puth(out_run[i]);
                }else{
                    // ݔs
                    length = 1;
                    uncomp.put(data[index]);
                }
            }else{
                // yApő
                if (length_pair != 0){
                    // yAp
                    length = length_pair;
                    uncomp.flush();
                    for (int i=0; i<cost_pair; i++) ohs.puth(out_pair[i]);
                }else{
                    // ݔs
                    length = 1;
                    uncomp.put(data[index]);
                }
            }
        }
        
        // ŌɁAp^[L^indexlengthi߂B
        for (int i=0; i<length; i++){
            pattern.add(data+index);
            index++;
        }
        
    }

	// ݔ̗Yɒ
    uncomp.flush();

	// I[̂邵
	ohs.puth(0x0);
	ohs.puth(0x0);

	ohs.flush();

    return true;
}














